/*
 * Copyright 
 *   2010 axYus - www.axyus.com
 *   2010 C ARIOUAT - assia.ariouat@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.controls.etatFrais.chorus;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;

import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;
import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
/**
 * Implémente le contrôle N° M045
 * 
 * Chaque ligne d'EF (éléments EtatsFrais/Invoice/InvoiceLine) doit avoir un seul (unique mais facultatif) élément EtatsFrais/Invoice/InvoiceLine/Item/AdditionalItemProperty/Name avec un texte est égal à ‘CH_PROJET_ANALYTIQUE_MINISTERIEL’

 */
public class M045 extends AbstractUnitControl {
	   private static final Logger logger = Logger.getLogger(M045.class);
	   public static final String CTRL_ID = "CTL-M045" ;
	   // pour stocker tous les paramètres d'execution des controles
	   private Hashtable<String,Object> hParams; 
	   // pour stocker les anomalies que l'on génère
	   Vector<Anomalie> anomalies = null;
	   // pour récupérer le texte des balises
	   private Stack<StringBuffer> chars = new Stack<StringBuffer>();
	   
	   /**
		 * Variables contenant les valeurs nécessaires à ce contrôle
		 */
	   
       private String Item_NodeId= "";
	   private int compteur_Name=0;
	   private String STRING_TO_COMPARE="CH_PROJET_ANALYTIQUE_MINISTERIEL";
       private String ID_Invoice="";
       private String ID_InvoiceLine="";
	   private String ID_Invoice_Unique = "";

    
	     /**
	 	 * Variables devant être remplacées dans le message
	 	 */
	 	private static final String MSG_IDLINE = "#IDLINE#";
	 	private static final String MSG_IDInvoice ="#ID_Invoice#";
	 	private static final String MSG_ERREUR = "#ERREUR#";
	     
 	
	     /**
	 	 * Chemins vers les divers éléments que l'on veux lire
	 	 */
	    public static final transient String RESET_COUNTER_PATH ="EtatsFrais/Invoice/";
	    public static final transient String REQUIRED_PATH = "EtatsFrais/Invoice/InvoiceLine/Item/AdditionalItemProperty/Name/";
	    public static final transient String InvoiceLine_PATH ="EtatsFrais/Invoice/InvoiceLine/";
	    public static final transient String InvoiceLine_ID ="EtatsFrais/Invoice/InvoiceLine/ID/";
	    public static final transient String InvoiceLine_Item ="EtatsFrais/Invoice/InvoiceLine/Item/";
	    public static final transient String RETURN_ANOMALIES_PATH = RESET_COUNTER_PATH;
	    public static final transient String ID_Invoice_PATH ="EtatsFrais/Invoice/ID/";

   public void endDocument() throws SAXException { }

   public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
    
	   if(xpath.equals(InvoiceLine_Item )) {
		   Item_NodeId=atts.getValue("ano:node-id");	  
	   }	
	   
	   if (xpath.equals(InvoiceLine_PATH)){
		   //nombre de ..AdditionalItemProperty/Name='CH_PROJET_ANALYTIQUE_MINISTERIEL' dans un même InvoiceLine 
		   compteur_Name=0;
		   Item_NodeId="";
		   ID_InvoiceLine = "";	
	   }
	   
       if(xpath.equals(RESET_COUNTER_PATH)) {
           // on commence un nouveau Invoice :
    	   //vider le vecteur d'anomalie 
           anomalies = new Vector<Anomalie>();
           ID_Invoice=""; 
           ID_Invoice_Unique = atts.getValue("ano:unique-id");

       }
       
	    // A chaque nouvel élément, on vide la Stack
	       chars.push(new StringBuffer());
   }
   
   public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
	   String erreur = "";

	   if (xpath.equals(REQUIRED_PATH)){
	        if(chars.peek().toString().equals(STRING_TO_COMPARE)) {	
	    	 compteur_Name++;
	         }
	    }
	   if(xpath.equals(InvoiceLine_ID )) {
		   ID_InvoiceLine = chars.peek().toString();
	   }
	        	 
	      
	   if (xpath.equals(ID_Invoice_PATH)) {    
	       ID_Invoice=chars.peek().toString();
	   }
		   
	     if (xpath.equals(InvoiceLine_PATH) && (compteur_Name>1)) {
		     
				erreur = "AdditionalItemProperty/Name CH_PROJET_ANALYTIQUE_MINISTERIEL doit etre unique pour chaque ligne d EF";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_IDLINE, String.valueOf(ID_InvoiceLine));
				msg = msg.replaceAll(MSG_IDInvoice, ID_Invoice);
				msg = msg.replaceAll(MSG_ERREUR, erreur);				
				
				String path = "@ano:unique-id='" + ID_Invoice_Unique + "'";
                String anoId = IdGenerator.nextId();
				String libelleLien = "Invoice "+ID_Invoice;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("anoId", anoId);
				xslParams.put("presentation", "src");
				Anomalie ano = new Anomalie(anoId,
				                        getDocumentModel().getControlById(CTRL_ID),
				                        getDocumentModel().getDocumentId(),
	                                    "EtatFrais",
	                                    "invoice",
	                                    ID_Invoice,
	                                    localName,
	                                    libelleLien,
	                                    msg,
	                                    getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
	                                    getDocumentModel().getControlById(CTRL_ID).getSeverity(),
	                                    path,
	                                    xslParams);
				ano.addNode(new Node(Item_NodeId));
				anomalies.add(ano);
				chars.pop();
				return null;
				
	       } 
	       else if (xpath.equals(RETURN_ANOMALIES_PATH)){
		    	   chars.pop();
				   return anomalies;
	             } 
	              else {
					       chars.pop();
					       return null;
	             }
    }
	   
   private void Println(String partyIdentification) {
	// TODO Auto-generated method stub
	
}

		public void characters(char[] ch, int start, int length, String xpath) throws SAXException {
	       //on stocke les caractères lus       
	       chars.peek().append(ch, start, length);
	   }

	   public void ignorableWhitespace(char[] ch, int start, int length, String xpath) throws SAXException { }
	
	   public void processingInstruction(String target, String data, String xpath) throws SAXException { }
	
	   public void skippedEntity(String name, String xpath) throws SAXException { }
	
	   public void setParameters(Hashtable<String, Object> params) {
	       this.hParams=params;
	   }
	
	   public void setDocumentLocator(Locator locator) { }
	
	   public void startDocument() throws SAXException {
		   logger.info("In "+CTRL_ID);
	   }
	
	   public void startPrefixMapping(String prefix, String uri, String xpath) throws SAXException { }
	
	   public void endPrefixMapping(String prefix, String xpath) throws SAXException { }
	}
	
